diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/check-style-clang-format.py ns-3.40/utils/check-style-clang-format.py
--- ns-3.39/utils/check-style-clang-format.py	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils/check-style-clang-format.py	2023-09-27 13:30:37.934840000 -0700
@@ -772,3 +729,8 @@
     except Exception as e:
         print(e)
         sys.exit(1)
+
+    if all_checks_successful:
+        sys.exit(0)
+    else:
+        sys.exit(1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/create-module.py ns-3.40/utils/create-module.py
--- ns-3.39/utils/create-module.py	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils/create-module.py	2023-09-27 13:30:37.934840000 -0700
@@ -336,7 +336,7 @@
     artifact_path = Path(path)
 
     #open file for (w)rite and in (t)ext mode
-    with artifact_path.open("wt") as f:
+    with artifact_path.open("wt", encoding="utf-8") as f:
         f.write(template.format(**kwargs))
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/grid.py ns-3.40/utils/grid.py
--- ns-3.39/utils/grid.py	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils/grid.py	2023-09-27 13:30:37.934840000 -0700
@@ -14,7 +14,7 @@
     #  end
     ## @var value
     #  value
-    def __init__(self, start = 0, end = 0, value = ''):
+    def __init__(self, start=0, end=0, value=''):
         """! Initializer
         @param self this object
         @param start start
@@ -30,7 +30,7 @@
     #  at
     ## @var value
     #  value
-    def __init__(self, at = 0, value = ''):
+    def __init__(self, at=0, value=''):
         """! Initializer
         @param self this object
         @param at you
@@ -44,7 +44,7 @@
     #  at
     ## @var value
     #  value
-    def __init__(self, at = 0, value = 0.0):
+    def __init__(self, at=0, value=0.0):
         """! Initializer
         @param self this object
         @param at you
@@ -58,7 +58,7 @@
     #  at
     ## @var value
     #  value
-    def __init__(self, at = 0, value = 0.0):
+    def __init__(self, at=0, value=0.0):
         """! Initializer
         @param self this object
         @param at you
@@ -88,7 +88,7 @@
     #  name
     ## @var ranges
     #  ranges
-    def __init__(self, name = ''):
+    def __init__(self, name=''):
         """! Initializer
         @param self this object
         @param name name
@@ -154,13 +154,13 @@
         s = self.__search(start)
         e = self.__search(end)
         if s == -1 and e == -1:
-            return(0, 0)
+            return (0, 0)
         elif s == -1:
-            return(0, e + 1)
+            return (0, e + 1)
         elif e == -1:
-            return(s, len(self.ranges))
+            return (s, len(self.ranges))
         else:
-            return(s, e + 1)
+            return (s, e + 1)
     def sort(self):
         """! Sort ranges
         @param self this object
@@ -175,16 +175,16 @@
         if len(self.ranges) > 0:
             lo = self.ranges[0].start
             hi = self.ranges[len(self.ranges)-1].end
-            return(lo, hi)
+            return (lo, hi)
         else:
-            return(0, 0)
+            return (0, 0)
 ## TimelineEvent class
 class TimelineEvent:
     ## @var name
     #  name
     ## @var events
     #  events
-    def __init__(self, name = ''):
+    def __init__(self, name=''):
         """! Get ranges bounds
         @param self this object
         @param name name
@@ -235,7 +235,7 @@
         """
         s = self.__search(start)
         e = self.__search(end)
-        return(s, e + 1)
+        return (s, e + 1)
     def sort(self):
         """! Sort function
         @param self this object
@@ -250,9 +250,9 @@
         if len(self.events) > 0:
             lo = self.events[0].at
             hi = self.events[-1].at
-            return(lo, hi)
+            return (lo, hi)
         else:
-            return(0, 0)
+            return (0, 0)
 
 ## Timeline class
 class Timeline:
@@ -264,7 +264,7 @@
     #  event string
     ## @var event_int
     #  event int
-    def __init__(self, name = ''):
+    def __init__(self, name=''):
         """! Initializer
         @param self this object
         @param name name
@@ -363,7 +363,7 @@
                 lo = ev_lo
             if ev_hi > hi:
                 hi = ev_hi
-        return(lo, hi)
+        return (lo, hi)
 
 ## Timelines class
 class Timelines:
@@ -412,7 +412,7 @@
                 lo = t_lo
             if t_hi > hi:
                 hi = t_hi
-        return(lo, hi)
+        return (lo, hi)
     def get_all_range_values(self):
         """! Get All Ranges
         @param self this object
@@ -433,7 +433,7 @@
     #  green
     ## @var b
     #  blue
-    def __init__(self, r = 0.0, g = 0.0, b = 0.0):
+    def __init__(self, r=0.0, g=0.0, b=0.0):
         """! Initializer
         @param self: this object
         @param r: red
@@ -587,8 +587,6 @@
             ctx.show_text(legend)
             i += 1
 
-        return
-
 ## TimelinesRenderer class
 class TimelinesRenderer:
     ## @var padding
@@ -797,7 +795,7 @@
         for timeline in self.timelines.get_all():
             (y_bearing, t_width, t_height) = ctx.text_extents(timeline.name)[1:4]
             ctx.move_to(left_x_start, cur_y + self.max_text_height - (t_height + y_bearing))
-            ctx.show_text(timeline.name);
+            ctx.show_text(timeline.name)
             for events_int in timeline.get_events_int():
                 (y_bearing, t_width, t_height) = ctx.text_extents(events_int.name)[1:4]
                 ctx.move_to(right_x_start, cur_y + self.max_text_height - (t_height + y_bearing))
@@ -830,7 +828,6 @@
                        0, bot_y)
         self.draw_line(ctx, right_x_end + self.padding / 2, 0,
                        0, bot_y)
-        return
 
 ## ScaleRenderer class
 class ScaleRenderer:
@@ -869,7 +866,7 @@
         @param x x
         @return real x
         """
-        real_x = (x - self.__lo ) * self.__width / (self.__hi - self.__lo)
+        real_x = (x - self.__lo) * self.__width / (self.__hi - self.__lo)
         return real_x
     def set_top(self):
         """! Set Top
@@ -899,7 +896,7 @@
             closest *= 10
         if (data_delta / closest) == 0:
             delta = closest
-        elif(data_delta / closest) == 1:
+        elif (data_delta / closest) == 1:
             delta = closest / 10
         else:
             delta = closest
@@ -940,7 +937,7 @@
         ctx.set_line_width(1.0)
         ticks = range(int(start), int(end + delta), int(delta))
         for x in ticks:
-            real_x = (x - self.__lo ) * self.__width / (self.__hi - self.__lo)
+            real_x = (x - self.__lo) * self.__width / (self.__hi - self.__lo)
             ctx.move_to(real_x, 0)
             ctx.line_to(real_x, 5*s)
             ctx.close_path()
@@ -958,7 +955,7 @@
             start = self.__lo - (self.__lo % delta) + delta
             end = self.__hi - (self.__hi % delta)
             for x in range(int(start), int(end + delta), int(delta)):
-                real_x = (x - self.__lo ) * self.__width / (self.__hi - self.__lo)
+                real_x = (x - self.__lo) * self.__width / (self.__hi - self.__lo)
                 ctx.move_to(real_x, 0)
                 ctx.line_to(real_x, 3*s)
                 ctx.close_path()
@@ -1024,7 +1021,7 @@
         """
         y_start = self.__top_legend.get_height()
         x_start = self.__data.get_data_x_start()
-        return(x_start, y_start, self.__width - x_start, self.__data.get_height())
+        return (x_start, y_start, self.__width - x_start, self.__data.get_height())
     def scale_data(self, x):
         """! Get Data Rectangle
         @param self this object
@@ -1044,7 +1041,7 @@
         y_height = self.__bot_scale.get_height() + 20
         x_start = self.__bot_scale.get_position(self.__r_start)
         x_end = self.__bot_scale.get_position(self.__r_end)
-        return(x_start, y_start, x_end - x_start, y_height)
+        return (x_start, y_start, x_end - x_start, y_height)
     def scale_selection(self, x):
         """! Scale Selection
         @param self this object
@@ -1074,7 +1071,7 @@
         @param self this object
         @return range
         """
-        return(self.__r_start, self.__r_end)
+        return (self.__r_start, self.__r_end)
     def set_data(self, data):
         """! Set Date
         @param self this object
@@ -1144,14 +1141,14 @@
         # data
         ctx.save()
         ctx.translate(0,
-                       top_legend_height)
+                      top_legend_height)
         self.__data.draw(ctx)
         ctx.restore()
 
         # scale below data
         ctx.save()
         ctx.translate(self.__data.get_data_x_start(),
-                       top_legend_height + self.__data.get_height() + self.__mid_scale.get_height())
+                      top_legend_height + self.__data.get_height() + self.__mid_scale.get_height())
         self.__mid_scale.draw(ctx)
         ctx.restore()
 
@@ -1177,7 +1174,7 @@
         select_end = self.__bot_scale.get_position(self.__r_end)
 
         # left connection between top scale and bottom scale
-        ctx.move_to(0, height_used);
+        ctx.move_to(0, height_used)
         ctx.line_to(self.__data.get_data_x_start(), height_used)
         ctx.line_to(select_start, height_used + 20)
         ctx.line_to(0, height_used + 20)
@@ -1206,12 +1203,12 @@
         unused_end = self.__bot_scale.get_position(self.__r_end)
         unused_height = self.__bot_scale.get_height() + 20
         ctx.rectangle(0, height_used,
-                       unused_start,
-                       unused_height)
+                      unused_start,
+                      unused_height)
         ctx.rectangle(unused_end,
-                       height_used,
-                       self.__width - unused_end,
-                       unused_height)
+                      height_used,
+                      self.__width - unused_end,
+                      unused_height)
         ctx.set_source_rgb(0.9, 0.9, 0.9)
         ctx.fill()
 
@@ -1584,7 +1581,6 @@
         dialog.set_default_response(1)
         dialog.connect("response", self.__dialog_response_cb)
         dialog.show()
-        return
     def __dialog_response_cb(self, widget, response):
         """! Dialog Response Callback
         @param self this object
@@ -1596,7 +1592,6 @@
             filename = self.__dialog.get_filename()
             self.__render.output_png(filename)
             widget.hide()
-        return
 
 
 ## read_data function
@@ -1608,7 +1603,7 @@
     m3 = re.compile('event-int ([^ ]+) ([^ ]+) ([0-9]+) ([0-9]+)')
     m4 = re.compile('color ([^ ]+) #([a-fA-F0-9]{2,2})([a-fA-F0-9]{2,2})([a-fA-F0-9]{2,2})')
 
-    with open(filename) as fh:
+    with open(filename, encoding='utf-8') as fh:
         for line in fh.readlines():
             m = m1.match(line)
             if m:
@@ -1654,7 +1649,6 @@
     return (colors, timelines)
 
 
-
 def main():
     (colors, timelines) = read_data(sys.argv[1])
     (lower_bound, upper_bound) = timelines.get_bounds()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/.ns3rc ns-3.40/utils/.ns3rc
--- ns-3.39/utils/.ns3rc	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils/.ns3rc	2023-09-27 13:30:37.934840000 -0700
@@ -2,6 +2,8 @@
 # Modules that depend on the listed modules will be enabled also.
 #
 # All modules can be enabled by emptying the list.
+# To list modules, append the modules separated by space or semicolon; e.g.:
+# set(ns3rc_enabled_modules core propagation)
 set(ns3rc_enabled_modules)
 
 # A list of the modules that will be disabled when ns-3 is run.
@@ -18,4 +20,4 @@
 
 # Override other ns-3 settings by setting their values below
 # Note: command-line settings will also be overridden.
-#set(NS3_LOG ON)
\ No newline at end of file
+#set(NS3_LOG ON)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/print-introspected-doxygen.cc ns-3.40/utils/print-introspected-doxygen.cc
--- ns-3.39/utils/print-introspected-doxygen.cc	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils/print-introspected-doxygen.cc	2023-09-27 13:30:37.934840000 -0700
@@ -456,8 +456,7 @@
     for (uint32_t i = 0; i < tid.GetAttributeN(); ++i)
     {
         struct TypeId::AttributeInformation info = tid.GetAttribute(i);
-        const PointerChecker* ptrChecker =
-            dynamic_cast<const PointerChecker*>(PeekPointer(info.checker));
+        const auto ptrChecker = dynamic_cast<const PointerChecker*>(PeekPointer(info.checker));
         if (ptrChecker != nullptr)
         {
             TypeId pointee = ptrChecker->GetPointeeTypeId();
@@ -482,7 +481,7 @@
             continue;
         }
         // attempt to cast to an object vector.
-        const ObjectPtrContainerChecker* vectorChecker =
+        const auto vectorChecker =
             dynamic_cast<const ObjectPtrContainerChecker*>(PeekPointer(info.checker));
         if (vectorChecker != nullptr)
         {
@@ -723,7 +722,7 @@
                 // Indirect cases to handle
                 if (valType == "ns3::PointerValue")
                 {
-                    const PointerChecker* ptrChecker =
+                    const auto ptrChecker =
                         dynamic_cast<const PointerChecker*>(PeekPointer(info.checker));
                     if (ptrChecker != nullptr)
                     {
@@ -734,7 +733,7 @@
                 }
                 else if (valType == "ns3::ObjectPtrContainerValue")
                 {
-                    const ObjectPtrContainerChecker* ptrChecker =
+                    const auto ptrChecker =
                         dynamic_cast<const ObjectPtrContainerChecker*>(PeekPointer(info.checker));
                     if (ptrChecker != nullptr)
                     {
@@ -1071,7 +1070,7 @@
        << "See ns3::GlobalValue for how to set these." << std::endl;
 
     os << listStart << std::endl;
-    for (GlobalValue::Iterator i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
+    for (auto i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
     {
         StringValue val;
         (*i)->GetValue(val);
@@ -1127,7 +1126,6 @@
     os << tLeft << ":" << std::string(widthL - 1, '-') << tMid << ":"
        << std::string(widthR - 1, '-') << tRight << std::endl;
 
-    LogComponent::ComponentList::const_iterator it;
     for (const auto& it : (*logs))
     {
         std::string file = it.second->File();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/tests/TestBase.py ns-3.40/utils/tests/TestBase.py
--- ns-3.39/utils/tests/TestBase.py	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils/tests/TestBase.py	2023-09-27 13:30:37.934840000 -0700
@@ -24,9 +24,9 @@
 
 def print_case_in_file(case_string, out):
     for i in range(100):
-        print("-", end = '', file = out)
+        print("-", end='', file=out)
     print(file=out)
-    print("running test case " + case_string, end='\n\n', file = out)
+    print("running test case " + case_string, end='\n\n', file=out)
     out.flush()
 
 def print_failed_cases(failed_cases):
@@ -40,10 +40,10 @@
         print(cmd.replace(sys.executable, ''))
 
 def set_workdir():
-    dir_files = [ f for f in os.listdir('.') if os.path.exists(f) ]
+    dir_files = [f for f in os.listdir('.') if os.path.exists(f)]
     if not 'VERSION' in dir_files and not 'ns3' in dir_files:
         if os.path.split(os.path.abspath('.'))[1] == 'tests' and os.path.split(os.path.abspath(os.pardir))[1] == 'utils':
-                os.chdir('../../')
+            os.chdir('../../')
         else:
             print('Error: Invalid working directory')
             sys.exit(1)
@@ -75,7 +75,7 @@
         self.my_env['LD_LIBRARY_PATH'] = os.getcwd() + "/build"
         self.mode = mode
         self.outfile = 'test-port-'+self.mode+'.out'
-        self.options = self.parseargs(argv , desc)
+        self.options = self.parseargs(argv, desc)
 
     def parseargs(self, argv, desc):
         """!
@@ -85,15 +85,15 @@
         @param desc description
         @return command line arguments
         """
-        parser = argparse.ArgumentParser(description = desc)
-        parser.add_argument('-f', '--file', action='store', dest='out_file', default = self.outfile,
+        parser = argparse.ArgumentParser(description=desc)
+        parser.add_argument('-f', '--file', action='store', dest='out_file', default=self.outfile,
                             metavar="FILE",
                             help='File to be used for storing the command specific output (Default: '+self.outfile+')')
         parser.add_argument('-c', action='store_true', dest='cmds', default=False,
                             help='List out all the commands being tested')
         parser.add_argument('-m', action='store_true', dest='mute', default=False,
                             help='Sends only stderr output to FILE')
-        parser.add_argument('-x', '--customcmd', action='store', dest='custcmd', default = None,
+        parser.add_argument('-x', '--customcmd', action='store', dest='custcmd', default=None,
                             help='Enter a comma-separated list of commands to override the existing ones. NOT APPLICABLE FOR TEST-PY SUITE.')
         return parser.parse_args(argv)
 
@@ -115,15 +115,15 @@
         if self.options.cmds:
             print_cmds(cmds)
             return
-
+        base_dir = os.sep.join(os.path.abspath(__file__).replace(os.path.pathsep, '/').split('/')[:-3])
         final_return = 0
         total_tests = len(cmds)
         passed = 0
         progress = 0.0
         failed_cases = []
-        with open(self.options.out_file, 'w') as out:
+        with open(self.options.out_file, 'w', encoding='utf-8') as out:
             outstream = out
-            with open(os.devnull, 'w') as sink:
+            with open(os.devnull, 'w', encoding='utf-8') as sink:
                 if self.options.mute:
                     outstream = sink
                 for cmd in cmds:
@@ -131,7 +131,13 @@
                     print("running test case: " + case_string)
                     print_case_in_file(case_string, out)
                     progress += 1
-                    ret = subprocess.call(cmd, shell=True, env=self.my_env, stdout=outstream, stderr=out)
+                    ret = subprocess.call(cmd,
+                                          shell=True,
+                                          env=self.my_env,
+                                          stdout=outstream,
+                                          stderr=out,
+                                          cwd=base_dir
+                                          )
                     if not ret:
                         passed += 1
                     else:
@@ -142,5 +148,5 @@
             print_failed_cases(failed_cases)
         else:
             print("\nAll cases passed")
-        print ("Detailed output available in " + self.options.out_file, end='\n\n')
+        print("Detailed output available in " + self.options.out_file, end='\n\n')
         return final_return
